import Flutter
import UIKit
import SecretHero

public class SecretheroFlutterPlugin: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "secrethero_flutter", binaryMessenger: registrar.messenger())
        let secretHeroFlutter = SecretHeroFlutter(channel: channel)
        let instance = SecretheroFlutterPlugin(secretHeroFlutter: secretHeroFlutter)
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    let secretHeroFlutter: SecretHeroFlutter
    
    init(secretHeroFlutter: SecretHeroFlutter) {
        self.secretHeroFlutter = secretHeroFlutter
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        guard let method = SecretHeroMethods.init(rawValue: call.method) else {
            result(FlutterMethodNotImplemented)
            return
        }
        let params = call.arguments as? [String: Any?] ?? [:]
        secretHeroFlutter.onMethod(method: method, params: params, result: result)
    }
}
